=== debian/changelog ===
supertux (0.3.4-1build1) trusty; urgency=medium

  * Rebuild against glew 1.10.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 06 Jan 2014 20:43:34 +0000

supertux (0.3.4-1) experimental; urgency=low

  * New upstream release.
    - Remove patches applied upstream:
      fix_{man_page,curl_ftbfs,gcc{4.6,4.7}_ftbfs,joystick_conf_loss}.patch
    - Refresh remaining patches.
  * Remove unnecessary Build-Conflicts field.
  * Remove unused lintian override.
  * Update watch file (thanks to Bart Martens).

 -- Vincent Cheng <Vincentc1208@gmail.com>  Tue, 20 Aug 2013 01:04:26 -0700
