=== debian/control ===
Source: supertux
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bartosz Fenski <fenio@debian.org>,
  Christoph Egger <christoph@debian.org>,
  Alexander Reichle-Schmehl <tolimar@debian.org>,
  Vincent Cheng <Vincentc1208@gmail.com>
Build-Depends: debhelper (>= 9),
  libsdl1.2-dev,
  libsdl-image1.2-dev,
  libsdl-mixer1.2-dev,
  libphysfs-dev,
  cmake,
  libopenal-dev,
  autotools-dev,
  libboost-dev,
  libglew-dev,
  libcurl4-gnutls-dev
Standards-Version: 3.9.4
Vcs-Svn: svn://anonscm.debian.org/pkg-games/packages/trunk/supertux/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/supertux/
Homepage: http://supertux.lethargik.org/

Package: supertux
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, supertux-data (= ${source:Version})
Description: Classic 2D jump 'n run sidescroller with Tux
 SuperTux is a classic 2D jump 'n run sidescroller game in a similar
 style like the original SuperMario games. You play the role of Tux the
 Penguin, who must rescue Penny from the hands of the evil Nolok.

Package: supertux-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: supertux
Description: Classic 2D jump 'n run sidescroller with Tux (data files)
 SuperTux is a classic 2D jump 'n run sidescroller game in a similar
 style like the original SuperMario games. You play the role of Tux the
 Penguin, who must rescue Penny from the hands of the evil Nolok.
 .
 This package contains the data files required by SuperTux.
