=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_install:
	dh_install --exclude=COPYING --list-missing

override_dh_installchangelogs:
	dh_installchangelogs WHATSNEW.txt
