=== debian/watch ===
version=3
http://supertux.lethargik.org/download.html .*/supertux-(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
