=== external/squirrel/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,29 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
+
+## Apply patch that fixes some Coverity errors
+
+## Apply coverity patch to Squirrel?
+SET(APPLY_COVERITY_PATCH FALSE)
+SET(WORKING_DIR WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
+
+IF(APPLY_COVERITY_PATCH)
+  FIND_PROGRAM(PATCH_EXECUTABLE patch)
+  IF(PATCH_EXECUTABLE)
+    SET(PATCH_COMMAND git apply --whitespace=fix --inaccurate-eof)
+    # Find patch files
+    FILE(GLOB_RECURSE PATCH_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
+         ${CMAKE_CURRENT_SOURCE_DIR}/patches/*.patch
+         ${CMAKE_CURRENT_SOURCE_DIR}/patches/*.diff)
+
+    # Execute patch files
+    FOREACH(file ${PATCH_FILES})
+      MESSAGE(STATUS "Found patch file ${file}.")
+      EXECUTE_PROCESS(COMMAND ${PATCH_COMMAND} ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${WORKING_DIR})
+    ENDFOREACH(file)
+  ENDIF(PATCH_EXECUTABLE)
+ENDIF(APPLY_COVERITY_PATCH)
 
 ## Add include/ to include directories
