=== debian/changelog ===
supertux (0.3.5a-1) unstable; urgency=medium

  * Upload to unstable. (Closes: #720108)
  * New upstream release. (Closes: #785686)
    - Add build-dep on libsdl2-dev, libsdl2-image-dev, pkg-config,
      libvorbis-dev; drop build-dep on libsdl-image1.2-dev, 
      libsdl-mixer1.2-dev, libsdl1.2-dev.
  * Refresh existing patches.
  * Drop "--disable-sfx --disable-music" args in supertux menu file; sound
    effects and music are no longer excluded due to DFSG incompatibility.
  * Update debian/copyright.
  * Fix lintian warning script-not-executable. (LP: #1385675)
  * Bump standards version to 3.9.6.
  * Update watch file.
  * Update my email address.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 01 Jun 2015 22:48:24 -0700
