=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 	dh $@ 
 
 override_dh_install:
+	# Fix lintian warning script-not-executable
+	chmod +x $(CURDIR)/debian/tmp/usr/share/games/supertux2/sounds/normalize.sh
 	dh_install --exclude=COPYING --list-missing
 
 override_dh_installchangelogs:
